VERSION 5.00
Begin VB.Form frmModelToolsDichte 
   Caption         =   "ModelTools - Dichte "
   ClientHeight    =   2265
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2805
   Icon            =   "frmModelToolsDichte.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   2265
   ScaleWidth      =   2805
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox cmbAuswahl 
      Height          =   315
      Left            =   1440
      Style           =   2  'Dropdown-Liste
      TabIndex        =   4
      ToolTipText     =   "Bitte Material als Klartext auswhlen"
      Top             =   960
      Width           =   1215
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Ende"
      Height          =   375
      Left            =   1800
      TabIndex        =   3
      ToolTipText     =   "Beendet das Programm"
      Top             =   1800
      Width           =   855
   End
   Begin VB.CommandButton cmdSetDensity 
      Caption         =   "Dichte nach &SWX bertragen"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "Durch diese Funktion wird der aktuelle Dichtewert aus dem Textfeld in SWX eingetragen"
      Top             =   1320
      Width           =   2535
   End
   Begin VB.CommandButton cmdGetDensity 
      Caption         =   "&Dichte vom Modell auslesen"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "Durch diese Funktion wird der aktuelle Dichtewert aus SWX ausgelesen und im Textfeld eingetragen"
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label lblDensity 
      Caption         =   "0,001"
      Height          =   255
      Left            =   1560
      TabIndex        =   6
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label lblAuswahl 
      Caption         =   "Bitte auswhlen"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   960
      Width           =   1335
   End
   Begin VB.Label lblDichte 
      AutoSize        =   -1  'True
      Caption         =   "Dichte [kg/m] ="
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   1155
   End
End
Attribute VB_Name = "frmModelToolsDichte"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim DichteName(2) As String
Dim DichteWert(2) As Double

' Einige Deklarationen aus der swconst.bas, aber nur die,
' die wir brauchen. Man kann natrlich auch einfach die swconst.bas
' als Modul dem VB-Projekt hinzufgen (mache ich normalerweise so)
Public Enum swDocumentTypes_e
    swDocPART = 1
    swDocASSEMBLY = 2
    swDocDRAWING = 3
End Enum
Public Enum swUserPreferenceDoubleValue_e
    swMaterialPropertyDensity = 7
End Enum

Private Sub cmdGetDensity_Click()
    ' Jetzt geht's los: an Solidworks anklinken, aktives Modell
    ' herausfinden und Dichte herausfischen
    
    ' wir bekommen ber die API einen Zeiger auf die Objekte, mit denen
    ' wir dann arbeiten knnen. Also mssen wir erstmal entsprechende
    ' Objektvariablen deklarieren
    Dim SwApp As Object
    Dim ModelDoc As Object
    ' An das aktive Solidworks-Modell anklinken. Wenn noch kein SWX
    ' lief, wird eins geladen
    Set SwApp = CreateObject("SldWorks.Application")
    ' wenn eines geladen wird oder die bestehende Session aus irgendeinem
    ' Grund versteckt war, sehen wir die logischerweise nicht. Also
    ' in jedem Fall auch noch sichtbar machen.
    SwApp.Visible = True
    Set ModelDoc = SwApp.ActiveDoc
    ' wenn nix geladen direkt wieder raus
    If ModelDoc Is Nothing Then
        Call MsgBox("*** Keine Datei geffnet ***", vbOKOnly)
        Exit Sub
    End If
    ' jetzt berprfen, ob das aktive Dokument ein Modell ist, denn nur
    ' darin knnen wir sinnvoll die aktuelle Dichte auslesen
    If ModelDoc.Gettype() <> swDocPART Then
        ' Kein Part, keine ktschen :-))
        Call MsgBox("*** Aktives Dokument ist kein Part ***", vbOKOnly)
        Exit Sub
    End If
    ' so, jetzt sind wir am Model angeklinkt, also die Dichte rauslesen
    ' die Funtkion hat zu funktionieren, es gibt keine explizite
    ' "Hat geklappt oder auch nicht" Rckgabe
    Dim retval As Double
    retval = ModelDoc.GetUserPreferenceDoubleValue( _
                            swMaterialPropertyDensity)
    '
    ' und den Wert jetzt noch eintragen ins Label
    lblDensity.Caption = retval
    '
End Sub

Private Sub cmdSetDensity_Click()
    ' an Solidworks anklinken und Dichte eintragen
    ' Kommentare siehe auch cmdGetDensity_Click
    Dim SwApp As Object
    Dim ModelDoc As Object
    
    Set SwApp = CreateObject("SldWorks.Application")
    SwApp.Visible = True
    
    Set ModelDoc = SwApp.ActiveDoc
    If ModelDoc Is Nothing Then
        Call MsgBox("*** Keine Datei geffnet ***", vbOKOnly)
        Exit Sub
    End If
    If ModelDoc.Gettype() <> swDocPART Then
        Call MsgBox("*** Aktives Dokument ist kein Part ***", vbOKOnly)
        Exit Sub
    End If
    
    ' so, jetzt sind wir am Model angeklinkt, also die Dichte setzen
    Dim retval As Boolean
    retval = ModelDoc.SetUserPreferenceDoubleValue( _
                            swMaterialPropertyDensity, _
                            DichteWert(cmbAuswahl.ListIndex))
    If retval Then
        ' ERFOLG!!!
        Call MsgBox("Dichtewert erfolgreich gesetzt", vbOKOnly)
    Else
        ' Upps, setzen hat nicht geklappt
        Call MsgBox("*** Konnte Dichte nicht setzen ***", vbOKOnly)
    End If
    '
End Sub
Private Sub Form_Load()
    ' vorher einige Standardwerte vorgeben, wenn mehr eingetragen werden
    ' sollen auch die Variablendeklarartion im Allgemeinen Teil anpassen
    '
    ' Dichte wird in SI Einheiten kg/m^3 angegeben, deswegen die
    ' grossen Werte. Nicht schocken lassen, in SWX werden die Werte in
    ' g/mm^3 angegeben, wenn wir das umrechnen ...
    DichteName(0) = "Wasser"
    DichteWert(0) = 1000
    DichteName(1) = "Aluminium"
    DichteWert(1) = 2700
    DichteName(2) = "Stahl"
    DichteWert(2) = 7850
    
    Dim i As Integer
    ' erstmal alle Werte, die vielleicht vorhanden sind rauswerfen
    cmbAuswahl.Clear
    For i = 0 To UBound(DichteName)
        ' mit den vorgegebenen Werten die Dropdownliste fllen
        cmbAuswahl.AddItem DichteName(i)
    Next i
    
    'und den Eintrag fr Stahl standardmig auswhlen
    cmbAuswahl.ListIndex = 2
    '
End Sub

Private Sub cmbAuswahl_Click()
    ' wenn ein anderer Eintrag gewhlt wird auch den Klartext aktualisieren
    lblDensity.Caption = DichteWert(cmbAuswahl.ListIndex)
End Sub

Private Sub cmdExit_Click()
    ' Programm beenden
    End
End Sub


